      Point3D a = fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex];
      Point3D b = fVertices[fTriangulatedFaces[i].fVertices[1].fVertexIndex];
      Point3D c = fVertices[fTriangulatedFaces[i].fVertices[2].fVertexIndex];

      Vector3D directionab = Vector3D(fVertices[fTriangulatedFaces[i].fVertices[1].fVertexIndex]) -
                             Vector3D(fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex]);
      Vector3D directionac = Vector3D(fVertices[fTriangulatedFaces[i].fVertices[2].fVertexIndex]) -
                             Vector3D(fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex]);

      Point3D p((genericRay.fDirection.fY * directionac.fZ -
                 genericRay.fDirection.fZ * directionac.fY),
                (genericRay.fDirection.fZ * directionac.fX -
                 genericRay.fDirection.fX * directionac.fZ),
                (genericRay.fDirection.fX * directionac.fY -
                 genericRay.fDirection.fY * directionac.fX));

      double alpha = directionab.fX * p.fX +
                     directionab.fY * p.fY +
                     directionab.fZ * p.fZ;

      if (Math::abs(alpha) < Math::kEpsilon) {
        continue;
      }

      double phi = 1.0 / alpha;

      Point3D s(genericRay.fStart.fX - a.fX,
                genericRay.fStart.fY - a.fY,
                genericRay.fStart.fZ - a.fZ);

      double u = ((s.fX * p.fX) +
                  (s.fY * p.fY) +
                  (s.fZ * p.fZ)) * phi;

      if ((u < 0.0) ||
          (u > 1.0)) {
        continue;
      }

      Point3D q((s.fY * directionab.fZ) - (s.fZ * directionab.fY),
                (s.fZ * directionab.fX) - (s.fX * directionab.fZ),
                (s.fX * directionab.fY) - (s.fY * directionab.fX));

      double v = ((genericRay.fDirection.fX * q.fX) +
                  (genericRay.fDirection.fY * q.fY) +
                  (genericRay.fDirection.fZ * q.fZ)) * phi;

      if ((v < 0.0) ||
          ((u + v) > 1.0)) {
        continue;
      }

      double hitTime = ((directionac.fX * q.fX) +
                        (directionac.fY * q.fY) +
                        (directionac.fZ * q.fZ)) * phi;
