// ------------------------------
// Filename      : constants.h
// Author        : Sven Maerivoet
// Last modified : 06/06/2001
// Target        : C++ (OpenGL)
//
// All rights reserved.
// ------------------------------

#ifndef SM_CONSTANTS_H
#define SM_CONSTANTS_H

static const int    kPolygonCircleApproximation     = 256;
static const int    kSphereSlices                   = 40;
static const int    kSphereStacks                   = 40;
static const int    kTaperedCylinderSlices          = 20;
static const int    kTaperedCylinderStacks          = 24;
static const int    kTorusSlices                    = 20;
static const int    kTorusStacks                    = 24;
static const int    kAlgebraicSurfaceSlices         = 20;
static const int    kAlgebraicSurfaceStacks         = 24;
static const int    kMaxObjectsPierced              = 50;
static const int    kMaxHits                        = 50;
static const int    kMaxSolidTextureParameters      = 11;
static const int    kMaxProceduralTextureParameters = 6;
static const int    kMaxAlgebraicSurfaceDegree      = 4;
static const double kJitterStrengthFactor           = 4.0;

static       double fMeshEpsilon                    = 1E-6;

#endif
